Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.sort
Class CodepointCollatingComparer

    java.lang.Object
      net.sf.saxon.sort.CodepointCollatingComparer

All Implemented Interfaces:
  Serializable, AtomicComparer

    public class CodepointCollatingComparer

extends Object
implements AtomicComparer

An AtomicComparer used for comparing strings, untypedAtomic values, and URIs using the Unicode codepoint collation. A CodepointCollatingComparer is used when it is known in advance that both operands will be of these types, and when the collation is the unicode codepoint collation. This enables all conversions and promotions to be bypassed: the string values of both operands are simply extracted and passed to the collator for comparison.

The difference between using this class and using the underlying CodepointCollator directly is that the compare() method in this class expects two instances of AtomicValue as its operands, whereas the underlying class expects two instances of java.lang.String. This class makes use of the extra information held in the wrapping StringValue object, specifically, the knowledge of whether the string contains surrogate pairs.

Author:
  Michael H. Kay
See Also:
  Serialized Form

Method Summary
`int` | `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` | `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality.
`ComparisonKey` | `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
`static CodepointCollatingComparer` | `getInstance()`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getInstance

    public static CodepointCollatingComparer getInstance()

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. This must be either be an instance of AtomicValue, or null to represent an empty sequence. Empty collates before non-empty.
    `b` - the second object to be compared. This must be either be an instance of AtomicValue, or null to represent an empty sequence.
  Returns:
    <0 if a0 if a>b
  Throws:
    `ClassCastException` - if the objects are not comparable

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)

  Compare two AtomicValue objects for equality. The values must be instances of xs:string or a type derived from xs:string. The method will also handle xs:untypedAtomic and xs:anyURI values.

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared.
    `b` - the second object to be compared.
  Returns:
    <0 if a0 if a>b
  Throws:
    `ClassCastException` - if either value is not xs:string or a subtype

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal under the XPath eq operator, then their comparison keys are equal under the Java equals() function, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.